import { GridType, Custom, GridObject, GridTypes, GridTypeLiteral, GridDefinitionLiteral, GridDefinitionCustomObject, GridObjectLiteral, CustomObject } from './types/grid';
export declare const DEFAULT_GRID_FRAMEWORK = "tailwind";
export declare const createGridObject: <T extends GridTypes>(config: GridType<T>) => GridObject<T>;
export declare const createConfigFromLiteral: (literal: GridDefinitionLiteral) => GridTypeLiteral<GridDefinitionLiteral>;
export declare const getCurrentBreakpoint: (config: Custom, object: CustomObject) => string;
export declare const updateComputedProperties: (config: Custom, object: CustomObject & {
    breakpoint: string;
}) => void;
export declare const createMediaQueries: (config: Custom, object: CustomObject & {
    breakpoint: keyof CustomObject;
}) => void;
export declare function useGrid<T extends GridDefinitionLiteral>(gridConfig: T): GridObjectLiteral<T>;
export declare function useGrid<T extends GridDefinitionCustomObject>(gridConfig: T): GridObject<T>;
export declare const extendGrid: <T extends GridDefinitionLiteral>(literalConfig: T, extraProperties: GridDefinitionCustomObject) => GridDefinitionCustomObject;
